type vehicule = {taille : int ; orientation : char ; rouge : bool ; posFixe : int ;  posMobile : int};;


type grille = vehicule array;;

type deplacement = {nbVehicule : int ; augmente : bool};;

let v0 = {taille = 2 ; orientation = 'h' ; rouge = true ; posFixe = 3; posMobile = 1};;
let v1 = {taille = 2 ; orientation = 'h' ; rouge = false ; posFixe = 5; posMobile = 0};;
let v2bis = {taille = 2 ; orientation = 'v' ; rouge = false ; posFixe = 5; posMobile = 0};;
let v2 = {taille = 2 ; orientation = 'h' ; rouge = false ; posFixe = 1; posMobile = 4};;
let v3 = {taille = 2 ; orientation = 'v' ; rouge = false ; posFixe = 0; posMobile = 0};;
let v4 = {taille = 3 ; orientation = 'h' ; rouge = false ; posFixe = 0; posMobile = 2};;
let v5 = {taille = 3 ; orientation = 'v' ; rouge = false ; posFixe = 0; posMobile = 2};;
let v6 = {taille = 3 ; orientation = 'v' ; rouge = false ; posFixe = 3; posMobile = 2};;
let v7 = {taille = 3 ; orientation = 'v' ; rouge = false ; posFixe = 5; posMobile = 3};;

let g0 = [|v0;v1;v2;v3;v4;v5;v6 ; v7|];;
let g0bis = [|v0;v1;v2bis;v3;v4;v5;v6 ; v7|];;

(**1**)
let grilleToNombre g modif =
  let p = (Array.length g) - 1 in
    let s = ref 0 in
      let mult = ref 1 in
        for i = 0 to p do
          s := !s + ((g.(i)).posMobile + modif.(i)) * !mult;
          mult := 5 * !mult
        done;
        !s;;



let nombreToGrille g0 n =
  let nb = ref n in
    let p = (Array.length g0) - 1 in
      let modif = Array.make (p + 1) 0 in
        for i = 0 to p do
          modif.(i) <- (!nb mod 5) - g0.(i).posMobile;
          nb := (!nb / 5);
        done;
        modif;; 



(**2**)


let sortie (g : grille) modif  = g.(0).posMobile + modif.(0) = 4;;



(**3**)
let caseOccuppee g0 modif i (x, y) =
  let fixe = ref true and mob = ref true in
  let veh = g0.(i) in
    if veh.orientation = 'v' then
      (fixe := (x = veh.posFixe);
        mob := ((veh.posMobile + modif.(i) <= y) && (y <= veh.posMobile + modif.(i) + veh.taille - 1))
      )
    else
      (fixe := (y = veh.posFixe);
        mob := ((veh.posMobile + modif.(i) <= x) && (x <= veh.posMobile + modif.(i) + veh.taille - 1))
      );
    !fixe && !mob;;




let deplacementValide g0 modif (i, b) =
  let p = (Array.length g0) - 1 in
    let veh = g0.(i) in
      let xnew = ref 0 and ynew = ref 0 in
        if veh.orientation = 'v' then
          (if b=1 then
              (xnew := veh.posFixe; ynew := veh.posMobile + modif.(i) + veh.taille)
            else
              (xnew := veh.posFixe; ynew := veh.posMobile + modif.(i) - 1))
        else
          (if b=1 then
              (ynew := veh.posFixe; xnew := veh.posMobile + modif.(i) + veh.taille)
            else
              (ynew := veh.posFixe; xnew := veh.posMobile + modif.(i) - 1)
          );
        let colision = ref false in
          for k = 0 to p  do
            if k <> i && (caseOccuppee g0 modif k  (!xnew, !ynew)) then colision := true;
          done;
          (!xnew <= 5 && !xnew >= 0 && !ynew <= 5 && !ynew >= 0 && not (!colision));;




(**4**)

let deplacementsPossibles g0 modif =
  let res = ref [] in
    let p = (Array.length g0) - 1 in
      for k = 0 to p do
        if deplacementValide g0 modif (k, 1) then res := (k, 1) :: !res;
        if deplacementValide g0 modif (k, - 1) then res := (k, - 1) :: !res
      done;
      !res;;


(**5**)
let faitDeplacement g0 modif (i, b) =
  let newModif = Array.copy modif in    
    newModif.(i) <- modif.(i) + b;
    newModif;;
  
let rec pow a n = if n = 0 then 1 else a*(pow a (n-1));;



 type  interne = { mutable precedent :  maillon;
                              etiquette : int;
                              mutable suivant :  maillon }
          and maillon =  | Vide
                            | Interne of  interne
          and  file =     { mutable premier :  maillon;
                              mutable dernier :  maillon };;

(*6*)

let creeFile () = {premier = Vide ; dernier = Vide};;

(*7*)
let estVide f = f.premier = Vide;;

(*8*)

let enfile a f = match f.dernier with
    | Vide -> let m = Interne ({precedent = Vide; etiquette = a; suivant = Vide}) in
          f.premier <- m; f.dernier <- m
    | Interne maill ->
        let m = Interne ({precedent = f.dernier; etiquette = a; suivant = Vide}) in
          maill.suivant <- m;
          f.dernier <- m
;;


(*9*)
let defile f = match f.premier with
    | Vide -> failwith "la file est vide"
    | Interne maill -> let etiq = maill.etiquette in match maill.suivant with
            | Vide -> f.premier <- Vide; f.dernier <- Vide; etiq
            | Interne maill2 -> f.premier <- Interne maill2; maill2.precedent <- Vide; etiq;;


(*10*)
let ajouteVoisins g0 mo f =
  let l = deplacementsPossibles g0 mo in
    let rec insertfile list f = match list with
        | [] -> ()
        | t :: q -> enfile (grilleToNombre g0 (faitDeplacement g0 mo t)) f;
            insertfile q f;
    in insertfile l f;;


let admetSolutions g0 =
  let p = (Array.length g0) - 1 in
    let modif = Array.make (p + 1) 0 in
      let f = creeFile () in enfile (grilleToNombre g0 modif) f;
        let nbsorti = ref (-1) in
          let visit = Array.make (pow 5 (p + 1)) false in
            while not (estVide f) && !nbsorti = (-1) do
              let nb = defile f in
                if not (visit.(nb)) then
                  begin visit.(nb) <- true;
                    let mo = nombreToGrille g0 nb in
                      if sortie g0 mo then nbsorti := nb;
                      ajouteVoisins g0 mo f
                  end
            done;
            !nbsorti;;


(*11*)
let ajouteVoisins2 g0 mo nb f prec visit=
  let l = deplacementsPossibles g0 mo in
    let rec insertfile list f = match list with
        | [] -> ()
        | t :: q -> let newnb = (grilleToNombre g0 (faitDeplacement g0 mo t)) in 
        enfile newnb f; if not(visit.(newnb)) then prec.(newnb) <- nb;
                    insertfile q f;
    in insertfile l f;;


let admetSolutions2 g0 =
  let p = (Array.length g0) - 1 in
    let modif = Array.make (p + 1) 0 in
      let f = creeFile () in enfile (grilleToNombre g0 modif) f;
        let nbsorti = ref (-1) in 
          let visit = Array.make (pow 5 (p + 1)) false in
          let precedent = Array.make (pow 5 (p + 1)) 0 in
            while not (estVide f) && (!nbsorti = -1) do
              let nb = defile f in
                if not (visit.(nb)) then
                  begin visit.(nb) <- true;
                    let mo = nombreToGrille g0 nb in
                      if sortie g0 mo then nbsorti := nb;
                      ajouteVoisins2 g0 mo nb f precedent visit
                  end
            done;
            precedent,!nbsorti;;


let solutions g0 = let (prec, nb) = admetSolutions2 g0 in
    let p = (Array.length g0) - 1 in
      let n0 = grilleToNombre g0 (Array.make (p + 1) 0) in
        if nb = - 1 then []
        else let rec remonte n acc = if n = n0 then acc
            else remonte (prec.(n)) (n :: acc)
          in remonte nb [];;

solutions g0;;



grilleToNombre g0 (Array.make (Array.length g0) 0);;
admetSolutions g0;;
snd(admetSolutions2 g0);;
solutions g0;;

admetSolutions g0bis;;
snd(admetSolutions2 g0bis);;
solutions g0bis;;
